#!/bin/env python2

# -*- coding: utf-8 -*-

from __future__ import unicode_literals
import wx
import icd10

class Icd10GUI(wx.Frame):
    def __init__(self, parent, id, title):
        wx.Frame.__init__(self, parent, id, title, size=(590, 450))
        panel = wx.Panel(self, -1)
        font = wx.SystemSettings_GetFont(wx.SYS_SYSTEM_FONT)
        font.SetPointSize(9)
        vbox = wx.BoxSizer(wx.VERTICAL)
        
        hbox1 = wx.BoxSizer(wx.HORIZONTAL)
        st1 = wx.StaticText(panel, -1, 'Suchbegriff')
        st1.SetFont(font)
        hbox1.Add(st1, 0, wx.RIGHT, 8)
        self.tc = wx.TextCtrl(panel, -1)
        hbox1.Add(self.tc, 1)
        vbox.Add(hbox1, 0, wx.EXPAND | wx.LEFT | wx.RIGHT | wx.TOP, 10)
        vbox.Add((-1, 10))
        
        hbox2 = wx.BoxSizer(wx.HORIZONTAL)
        st2 = wx.StaticText(panel, -1, 'Codes')
        st2.SetFont(font)
        hbox2.Add(st2, 0)
        vbox.Add(hbox2, 0, wx.LEFT | wx.TOP, 10)
        vbox.Add((-1, 10))
        
        hbox3 = wx.BoxSizer(wx.HORIZONTAL)
        self.tc2 = wx.TextCtrl(panel, -1, style=wx.TE_MULTILINE)
        hbox3.Add(self.tc2, 1, wx.EXPAND)
        vbox.Add(hbox3, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        vbox.Add((-1, 25))
        
        hbox5 = wx.BoxSizer(wx.HORIZONTAL)
        btn1 = wx.Button(panel, -1, 'Suche', size=(70, 30))
        hbox5.Add(btn1, 0)
        btn2 = wx.Button(panel, -1, 'Exit', size=(70, 30))
        hbox5.Add(btn2, 0, wx.LEFT | wx.BOTTOM , 5)
        vbox.Add(hbox5, 0, wx.ALIGN_RIGHT | wx.RIGHT, 10)
        panel.SetSizer(vbox)
        self.Centre()
        self.Show(True)
        
        self.Bind(wx.EVT_BUTTON, self.Suche, id=btn1.GetId())
        self.Bind(wx.EVT_BUTTON, self.Exit, id=btn2.GetId())
        btn1.SetDefault()
        
    def Exit(self, event):
        self.Close()
        
    def Suche(self, event):
        searchterm = self.tc.GetValue()
        
        with icd10.DatabaseConnector() as database:
            results = database.search(searchterm)
        self.tc2.SetValue('')
        for code in results:
            DiagText = code[1]
            self.tc2.AppendText("{0}   \t: {1}\n".format(code[0], DiagText))

app = wx.App()
Icd10GUI(None, -1, 'ICD10 Code Suche')
app.MainLoop()